; Quick Man Laser
; By Erik557


!TimeBefSpwn  = $40   ; time before the laser appears
!Sound        = $04   ;\ sfx and port. default: grinder
!SFXPort      = $1DFA ;/ plays every 4 frames

Tilemap:
       db $CE,$EE     ; Horizontals, Verticals
Map16:
       dw $0200,$0201 ; Horizontals, Verticals

XSpeed:
       db $30,$D0     ; to right, to left
       db $00,$00     ; don't touch
YSpeed:
       db $30,$D0     ; downwards, upwards

print "INIT ",pc
       LDA $7FAB28,x
       STA $1602,x
       LDA #!TimeBefSpwn
       STA $1540,x
       RTL

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR QuickManLaser
       PLB
       RTL

MainReturn:
       RTS
QuickManLaser:
       LDA $9D
       BNE .Draw
       LDY #$00
       JSR SubOffScreen
       LDA $1540,x
       BNE MainReturn
       LDY $1602,x
       LDA XSpeed,y
       STA $B6,x
       LDA YSpeed-2,y
       STA $AA,x
       
       JSL $01801A
       JSL $018022  

       LDA $14
       AND #$03
       BNE +
       LDA #!Sound
       STA !SFXPort

+      LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       AND #$FFF0
       STA $9A
       SEP #$20

       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       AND #$FFF0
       STA $98
       SEP #$20

       LDA $1602,x
       AND #$FE
       TAY
       JSR CheckMap16
       LDA [$05]
       XBA
       INC $07
       LDA [$05]
       XBA
       REP #$20
       CMP Map16,y
       SEP #$20
       BEQ +
       CMP #$25
       BNE .Destroy

+      PHP
       REP #$30
       LDA.w Map16,y
       STA $03
       JSR SUBL_SET_MAP16
       PLP
.Draw
       JSR Graphics
       BRA .Return
.Destroy
       STZ $14C8,x
       LDA #$FF
       STA $161A,x
       STZ !SFXPort
.Return
       RTS

;========================
; Graphics routine
;========================

Graphics:
       LDY #$10
       LDA $AA,x
       BMI +
       LDY #$01
+      STY $05
       LDY #$00
       LDA $B6,x
       BPL +
       LDY #$10
+      STY $06
       JSR GetDrawInfo
       LDA $00
       SEC : SBC $06
       STA $0300,y
       LDA $01
       SEC : SBC $05
       STA $0301,y
       LDA $1602,x
       LSR : TAX
       LDA Tilemap,x
       STA $0302,y
       LDX $15E9
       LDA $15F6,x
       ORA #$10
       STA $0303,y
       LDY #$02
       TDC
       JSL $01B7B3
       RTS

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS QuickManLaser_Destroy
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
       JMP QuickManLaser_Destroy
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

;================================================
  GetDrawInfo:            ; - Optimized version
;================================================

       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SEC
       SBC $1A
       STA $00
       CLC
       ADC #$0040
       CMP #$0180
       SEP #$20
       LDA $01
       BEQ +
       LDA #$01
+      STA $15A0,x
       TDC
       ROL A
       STA $15C4,x
       BNE .Invalid
       LDA $14D4,x
       XBA
       LDA $1662,x
       AND #$20
       BEQ .CheckOnce
.CheckTwice
       LDA $D8,x
       REP #$21
       ADC #$001C
       SEC
       SBC $1C
       SEP #$20
       LDA $14D4,x
       XBA
       BEQ .CheckOnce
       LDA #$02
.CheckOnce
       STA $186C,x
       LDA $D8,x
       REP #$21
       ADC #$000C
       SEC
       SBC $1C
       SEP #$21
       SBC #$0C
       STA $01
       XBA
       BEQ .OnScreenY
       INC $186C,x
.OnScreenY
       LDY $15EA,x
       RTS

.Invalid
       PLA
       PLA
       RTS

;;;;;;;;;;;;;;;;;;;
; map16 subroutine
;;;;;;;;;;;;;;;;;;;


SUBL_SET_MAP16:
       PHP
       REP #$30
       PHY
       PHX
       TAX
       LDA $03
       PHA
       JSR .Sub8034
       PLA
       STA $03
       PLX
       PLY
       PLP
       RTS

.Return18
       PLX
       PLB
       PLP
       RTS

.Sub8034
       PHP
       SEP #$20
       PHB
       LDA #$00
       PHA
       PLB
       REP #$30
       PHX
       LDA $9A
       STA $0C
       LDA $98
       STA $0E
       LDA.w #$0000
       SEP #$20
       LDA $5B
       STA $09
       LDA $1933
       BEQ .NoShift
       LSR $09
.NoShift
       LDY $0E
       LDA $09
       AND #$01
       BEQ .Horiz
       LDA $9B
       STA $00
       LDA $99
       STA $9B
       LDA $00  
       STA $99
       LDY $0C
.Horiz
       CPY #$0200
       BCS .Return18
       LDA $1933
       ASL
       TAX
       LDA $BEA8,x
       STA $65
       LDA $BEA9,x
       STA $66
       STZ $67
       LDA $1925
       ASL
       TAY
       LDA ($65),y
       STA $04
       INY
       LDA ($65),y
       STA $05
       STZ $06
       LDA $9B
       STA $07
       ASL
       CLC
       ADC $07
       TAY
       LDA ($04),y
       STA $6B
       STA $6E
       INY
       LDA ($04),y
       STA $6C
       STA $6F
       LDA #$7E
       STA $6D
       INC
       STA $70
       LDA $09
       AND #$01
       BEQ .NoAnd
       LDA $99
       LSR
       LDA $9B
       AND #$01
       BRA .Label52
.NoAnd
       LDA $9B
       LSR
       LDA $99
.Label52
       ROL
       ASL #2
       ORA #$20
       STA $04
       CPX.w #$0000
       BEQ .NoAdd
       CLC
       ADC #$10 
       STA $04
.NoAdd
       LDA $98
       AND #$F0
       CLC
       ASL
       ROL
       STA $05
       ROL
       AND #$03
       ORA $04
       STA $06
       LDA $9A
       AND #$F0
       LSR #3
       STA $04
       LDA $05
       AND #$C0
       ORA $04
       STA $07
       REP #$20
       LDA $09
       AND.w #$0001
       BNE .Label51
       LDA $1A
       SEC
       SBC.w #$0080
       TAX
       LDY $1C
       LDA $1933
       BEQ .Label50
       LDX $1E
       LDA $20
       SEC
       SBC.w #$0080
       TAY
       BRA .Label50
.Label51
       LDX $1A
       LDA $1C
       SEC
       SBC.w #$0080
       TAY
       LDA $1933
       BEQ .Label50
       LDA $1E
       SEC
       SBC.w #$0080
       TAX  
       LDY $20
.Label50
       STX $08
       STY $0A
       LDA $98
       AND #$01F0
       STA $04
       LDA $9A
       LSR #4
       AND.w #$000F
       ORA $04
       TAY
       PLA
       SEP #$20
       STA [$6B],y
       XBA
       STA [$6E],y
       XBA
       REP #$20
       ASL A
       TAY
       PHK
       PEA.w .Map16Return-$01
       PEA $804C
       JML $00C0FB|$800000
.Map16Return
       PLB
       PLP
       RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; (JSR) Routine to check Map16 tile in block positions 98-9B
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CheckMap16:
       LDA $98
       AND #$F0
       STA $06
       LDA $9A
       LSR #4
       ORA $06
       PHA
       LDA $5B
       AND #$01
       BEQ .CODE_01D977
       PLA
       LDX $99
       CLC
       ADC $00BA80,x
       STA $05
       LDA $00BABC,x
       ADC $9B
       STA $06
       BRA .CODE_01D989

.CODE_01D977
       PLA
       LDX $9B
       CLC
       ADC.l $00BA60,x
       STA $05
       LDA.l $00BA9C,x
       ADC $99
       STA $06

.CODE_01D989
       LDA.b #$7E
       STA $07
       LDX $15E9
       RTS

